=== modified file 'NEWS'
--- NEWS	2007-10-03 19:24:20 +0000
+++ NEWS	2007-10-17 11:56:50 +0000
@@ -22,6 +22,8 @@
 
   * Show children on new row in table to avoid very broad windows in viz. 
     (Jelmer)
+
+  * viz slow when run from olive. (#70463, Gary van der Merwe)
     
  INTERNALS
 

=== modified file '__init__.py'
--- __init__.py	2007-09-25 14:09:40 +0000
+++ __init__.py	2007-10-17 11:56:50 +0000
@@ -225,11 +225,9 @@
     :return: The viz window object.
     """
     from viz.branchwin import BranchWindow
-    branch.lock_read()
     pp = BranchWindow()
     pp.set_branch(branch, revision, limit)
     # cleanup locks when the window is closed
-    pp.connect("destroy", lambda w: branch.unlock())
     return pp
 
 

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-10-14 01:02:38 +0000
+++ viz/branchwin.py	2007-10-17 11:56:50 +0000
@@ -36,6 +36,7 @@
         self._parent = parent
 
         self.connect('key-press-event', self._on_key_pressed)
+        self.connect("destroy", lambda w: self.branch.unlock())
 
         # Use three-quarters of the screen by default
         screen = self.get_screen()
@@ -202,6 +203,7 @@
         gobject.idle_add(self.populate_model, start, maxnum)
 
     def populate_model(self, start, maxnum):
+        self.branch.lock_read()
         (linegraphdata, index, columns_len) = linegraph(self.branch,
                                                         start,
                                                         maxnum)

